#ifndef FORMATION_H
#define FORMATION_H

class PlayerTypeInfo
{
  double  dAttrX;     /*!< x attraction to the ball                          */
  double  dAttrY;     /*!< y attraction to the ball                          */
  double  dMinX;      /*!< minimal x coordinate for this player type         */
  double  dMaxX;      /*!< maximal x coordinate for this player type         */
  bool    bBehindBall;/*!< should player always stay behind the ball         */

public:
  PlayerTypeInfo( );

  // method to set all the values at once and displaying them all
  bool    setValues( double , double, double, double, bool  );

  // standard get and set methods to individually set all the values
  bool    setPlayerType    ( PlayerT type  );
  PlayerT getPlayerType    (               ) const;
  bool    setAttrX         ( double  attrX );
  double  getAttrX         (               ) const;
  bool    setAttrY         ( double  attrY );
  double  getAttrY         (               ) const;
  bool    setMinX          ( double  minX  );
  double  getMinX          (               ) const;
  bool    setMaxX          ( double  maxX  );
  double  getMaxX          (               ) const;
  bool    setBehindBall    ( bool    b     );
  bool    getBehindBall    (               ) const;

};

class FormationTypeInfo
{
  FormationT      formationType;               /*!< type of this formation   */
  VecPosition     posHome[ MAX_TEAMMATES ];    /*!< home position for roles  */
  PlayerT         playerType[ MAX_TEAMMATES ]; /*!< player_types for roles   */
  PlayerTypeInfo  playerTypeInfo[ MAX_PLAYER_TYPES ]; /*!< info for roles    */

public:
  FormationTypeInfo(                    );
  void show(         ostream &os = cout );

  // get and set methods to get information for a player in this formation
  bool            setFormationType         ( FormationT  type                );
  FormationT      getFormationType         (                            ) const;
  bool            setPosHome               ( VecPosition pos,     int atIndex);
  bool            setXPosHome              ( double      x,       int atIndex);
  bool            setYPosHome              ( double      y,       int atIndex);
  VecPosition     getPosHome               ( int         atIndex       ) const;
  bool            setPlayerType            ( PlayerT     type,    int atIndex);
  PlayerT         getPlayerType            ( int         atIndex       ) const;
  bool            setPlayerTypeInfo        ( PlayerTypeInfo info, int atIndex);
  PlayerTypeInfo* getPlayerTypeInfo        ( int         atIndex             );
  PlayerTypeInfo* getPlayerTypeInfoOfPlayer( int         iPlayerInFormation  );
};
#endif //FORMATION_H
